package bioinformatica.programmazione.esami.giugno.terzaparte;

/**
 * Rappresenta insiemi di stringe non modificabili.
 * 
 * @author mace
 * @version 1.0
 * 
 */

public interface Set {

	/**
	 * Verifica se l'insieme contiene <code>element</code>
	 * 
	 * @param element
	 *            elemento da verificare.
	 * @return <code>true</code> se <code>this</code> contiene
	 *         <code>element</code>; <code>false</code> altrimenti.
	 */
	boolean contains(String element);

	/**
	 * Verfica se l'insieme interseca <code>that</code>
	 * 
	 * @param that
	 *            insieme da verificare
	 * @return <code>true</code> se <code>this</code> interseca
	 *         <code>that</code>; <code>false</code> altrimenti.
	 */
	boolean intersects(Set that);

	/**
	 * Restituisce il numero di elementi dell'insieme.
	 * 
	 * @return numero di elementi dell'insieme.
	 */
	int size();

	/**
	 * Restituisce un array che contiene la copia degli elementi dell'insieme.
	 * 
	 * @return copia degli elementi dell'insieme
	 */
	String[] getElements();
}